#import "LotsaView.h"

#import <OpenGL/gl.h>
#import <OpenGL/glu.h>


@interface LELotsaEscherView:LotsaView 
{
	IBOutlet NSSlider *uslider,*vslider;
	IBOutlet NSMatrix *radiomatrix;
	IBOutlet NSTextView *creditview;

	int w,h;
	float u,v,dudt,dvdt;
	double t,t_prev;
	GLuint tex;
	struct texcoord  { float u,v; } *lookup;
	struct vertex { float x,y,u,v; } *vertices;
}

-(id)initWithFrame:(NSRect)frame isPreview:(BOOL)preview;
-(void)dealloc;

-(void)startAnimationWithDefaults:(ScreenSaverDefaults *)defaults;
-(void)stopAnimation;
-(void)animateOneFrame;

-(void)precalc:(double)p1 p2:(double)p2;

-(void)updateConfigWindow:(NSWindow *)window usingDefaults:(ScreenSaverDefaults *)defaults;
-(void)updateDefaults:(ScreenSaverDefaults *)defaults usingConfigWindow:(NSWindow *)window;

@end
