#import "EffectObject.h"



@implementation LGEffectObject

-(void)drawAtTime:(double)t matrix:(matrix)m firstMode:(int)mode1 secondMode:(int)mode2 fade:(float)fade
{
}

-(int)modes
{
	return 0;
}

@end




@implementation LGTriangleStripObject

-(id)initWithVertices:(int)nvertices andStrips:(int)nstrips ofSize:(int)stripsum
{
	if(self=[super init])
	{
		num_vertices=nvertices;
		num_strips=nstrips;
		vertices=(struct vertex *)malloc(sizeof(struct vertex)*num_vertices);
		strips=(int *)malloc(sizeof(int)*(stripsum+num_strips));
	}

	return self;
}

-(void)dealloc
{
	free(vertices);
	free(strips);

	[super dealloc];
}

-(void)drawStrips
{
	glTexCoordPointer(3,GL_FLOAT,sizeof(struct vertex),&vertices[0].tex);
	glColorPointer(4,GL_UNSIGNED_BYTE,sizeof(struct vertex),&vertices[0].r);
	glNormalPointer(GL_FLOAT,sizeof(struct vertex),&vertices[0].n);
	glVertexPointer(3,GL_FLOAT,sizeof(struct vertex),&vertices[0].v);

	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);
	glEnableClientState(GL_VERTEX_ARRAY);

	glLockArraysEXT(0,num_vertices);

	int *sptr=strips;
	for(int i=0;i<num_strips;i++)
	{
		int n=*sptr++;
//		glDrawElements(GL_LINE_STRIP,n,GL_UNSIGNED_INT,sptr);
		glDrawElements(GL_TRIANGLE_STRIP,n,GL_UNSIGNED_INT,sptr);
		sptr+=n;
	}

/*	glDisable(GL_TEXTURE_2D);
	glBegin(GL_LINES);
	glVertex3f(0,0,-2);
	glVertex3f(0,0,2);
	glEnd();*/

	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	glDisableClientState(GL_COLOR_ARRAY);
	glDisableClientState(GL_NORMAL_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);

	glUnlockArraysEXT();
}

@end
