#import "LotsaView.h"
#import "GLConverter.h"
#import "snow.h"

#import <OpenGL/gl.h>
#import <OpenGL/glext.h>
#import <OpenGL/glu.h>



@interface LSLotsaSnowView:LSLotsaView 
{
	NSMutableArray *flakes;
	NSBitmapImageRep *screenshot;

	float top_r,top_g,top_b;
	float bottom_r,bottom_g,bottom_b;
	float glare_r,glare_g,glare_b;
	float cycles_per_second;
	int max_growth;

	double t;

	flake_grower *grower;
	double growth_counter;
	int flake_growth;
	float screen_ratio;

	GLuint screentex;

	IBOutlet NSSlider *growthrate;
	IBOutlet NSColorWell *topcol;
	IBOutlet NSColorWell *bottomcol;
	IBOutlet NSColorWell *glarecol;
	IBOutlet NSButton *usedesktop;
	IBOutlet NSSlider *desktopfade;
	IBOutlet NSImageView *flakeview;
}

-(id)initWithFrame:(NSRect)frame isPreview:(BOOL)pre;
-(void)dealloc;

-(void)startAnimationWithDefaults:(ScreenSaverDefaults *)defaults;
-(void)stopAnimation;
-(void)animateOneFrame;

-(void)updateConfigWindow:(NSWindow *)window usingDefaults:(ScreenSaverDefaults *)defaults;
-(void)updateDefaults:(ScreenSaverDefaults *)defaults usingConfigWindow:(NSWindow *)window;

-(IBAction)makeNewSnowFlake:(id)sender;

+(BOOL)performGammaFade;

@end

@interface LSSnowFlake:NSObject
{
//	static int depthcmp(const void *a,const void *b);
	GLuint tex;

	float t;
	float x,y,z,x0,y0;
	float size,screen_ratio;
	float a,dadt;
}

-(id)initWithData:(void *)data size:(int)datasize ratio:(float)screen_ratio;
-(void)dealloc;

-(NSComparisonResult)compare:(LSSnowFlake *)flake;

-(BOOL)move:(double)dt;
-(void)draw;

-(float)z;

@end

@interface LSShadowedImageView:NSImageView
{
}

-(void)drawRect:(NSRect)rect;

@end
